yes		= 1
no		= 0
max		= 0xFFFFFFFF
DefMask = 0
include	"..\Settings.txt"
PreviousSize = 0
virtual at 0
	file	INNAME
	Default = 0
	SizeROM = $-1
	if SizeROM > 0x1FFFF
		Prologue = 0xFF0000
	else
		Prologue = 0
	end if
	InjectAddress = SizeROM - 7
	Pattern = 0
	while Pattern and 0xFFFFFFFFFFFF0000 <> 0xF08B5874C00B0000
		InjectAddress = InjectAddress - 1
		load Pattern qword from InjectAddress
		if % = 0x5000
			display 13,10,13,10,'ERROR:  Source ROM is corrupted or incompatible',13,10
			err
		end if
	end while
	InjectAddress = ((InjectAddress - 2) and 0xFFFF) or Prologue
	DriverAddress = ((InjectAddress + 0xD1D9) and 0xFFFF) or Prologue
	Masking = 0x7FE000FF
	load OriginalAddress dword from InjectAddress
	if OriginalAddress = 0xFFFFD1D5
		load Pattern qword from DriverAddress + 2
		if Pattern <> 0x63696C637265764F
			display 13,10,13,10,'ERROR:  Previous Driver record is corrupted',13,10
			err
		else
			display 13,10,13,10,'Rebuilding Driver',13,10,13,10,13,10
			load PreviousSize byte from DriverAddress + 11
			PreviousSize = PreviousSize shl 4
		end if
		load OriginalAddress dword from DriverAddress + 12
	else
		display 13,10,13,10,'Inserting Driver',13,10,13,10,13,10
	end if
end virtual
virtual at 0
	Pointer = $
	file	"..\Settings.txt"
	while Pattern and 0xFFFFFFFFFFFFFF00 <> 0x656E6961726B5500
		Pointer = Pointer + 1
		load Pattern qword from Pointer
		if % = 500
			OriginalAddress = 0
			DefMask = 0xFFF
			Masking = Masking + 0x7FE000FF
			Default = yes
			Break
		end if
	end while
	Masking = Masking - 0x7FE000FF
end virtual
file	INNAME:0,DriverAddress
use32
org 0
driver:
	jmp		start
	db		4Fh,76h,65h,72h,63h,6Ch,69h,63h,6Bh,(enddriver shr 4) + 1
	dd		OriginalAddress
start:
if CheckPowerButton = yes & Default <> yes
	mov		eax,0x8000F8A0
	mov		ecx,0xFFFF
	mov		dx,0xCF8
	out		dx,eax
	in		eax,dx
	test	eax,0x80000000
	jz		.skipjob
	mov		dx,0xCFC
	.timeout:
		in		ax,dx
		test	ax,1 shl 9
		jnz		startjob
		loop	.timeout
	.skipjob:
	mov		dx,6000
	.play:
	mov		ecx,0xFFFF
	mov     al, 182
	out     0x43, al
	mov     al, dl
	out     0x42, al
	mov     al, dh
	out     0x42, al
	in      al, 0x61
	or      al, 00000011b
	out     0x61, al
	.duration:
		in		al, 0x61
		and		al, 11111100b
		loop	.duration
	out		0x61, al
	add		dx,6000
	cmp		dx,12000
	je		.play
	jmp		endjob
startjob:
end if
if TDP_Level <> no
	mov		ecx,0x64B
 	rdmsr
	and		al,0xFC
	or		eax,(TDP_Level and 3) + (1 shl 31)
	wrmsr	
end if
if TurboRatio <> no | CoreVOffset <> no | TurboBoost = yes
	if TurboRatio = max
		mov		ecx,0x150
		xor		eax,eax
		mov		edx,0x80000001
		wrmsr
		rdmsr
		and		al,0x7F
		cmp		al,42
		jbe		.turboratioOK
		mov		al,42
		.turboratioOK:
		movzx	esi,al
	else if TurboRatio = no
		mov		ecx,0x1AD
		rdmsr
		and		al,0x7F
		movzx	esi,al
	else
		mov		esi,TurboRatio and 0x7F
	end if
end if
if TurboRatio <> no | CoreVOffset <> no | Default = yes
	mov		ecx,0x150
	mov		eax,esi
	if Default = yes
		mov		eax,0x0FE00000 or Masking
	else if CoreVOffset <> no
		or		eax,((CoreVOffset * 33554) shl 6) and 0xFFE00000
	end if
	mov		edx,0x80000011
	wrmsr
end if
if TurboBoost = yes
	mov		eax,1
	cpuid
	mov		edx,esi
	cmp		ax,0x306f
	je		.haswell
	cmp		ax,0x406f
	je		.broadwell
	and		eax,0xFFFF0
	cmp		eax,0x306f0
	je		.haswell
	cmp		eax,0x406f0
	je		.broadwell
	jmp		.turboend
	.haswell:
		mov		esi,0x80000000
		jmp		.turbojob
	.broadwell:
		xor		esi,esi
	.turbojob:
		mov		ecx,0x1AD
 		mov		dh,dl
 		mov		ax,dx
 		shl		eax,16
 		mov		ax,dx
 		mov		edx,eax
		wrmsr
		inc		ecx
		wrmsr
		inc		ecx
		or		edx,esi
		wrmsr
		test	esi,esi
		jnz		.turboend
		mov		ecx,0x1AC
		rdmsr
		or		edx,esi
		wrmsr
	.turboend:
end if
if MaxCache <> no | MinCache <> no | CacheVOffset <> no
	mov		ecx,0x620
	rdmsr
	and		eax,0x7F7F
	mov		ebx,eax
	if MaxCache = max
		mov		ecx,0x150
		xor		eax,eax
		mov		edx,0x80000201
		wrmsr
		rdmsr
		and		al,0x7F
		cmp		al,32
		ja		.cacheratiowrong
		mov		bl,al
		.cacheratiowrong:
	else if MaxCache <> no
		mov		bl,MaxCache and 0x7F
	end if
	if MinCache = max
		mov		bh,bl
	else if MinCache <> no
		mov		ax,bx
		mov		ah,MinCache and 0x7F
		cmp		ah,al
		cmovbe	bx,ax
		mov		ah,al
		cmova	bx,ax
	end if
end if
if MaxCache <> no | CacheVOffset <> no | Default = yes
	mov		ecx,0x150
	movzx	eax,bl
	if Default = yes
		mov		eax,0x0FE00000 or Masking
	else if CacheVOffset <> no
		or		eax,((CacheVOffset * 33554) shl 6) and 0xFFE00000
	end if
	mov		edx,0x80000211
 	wrmsr
end if
if MaxCache <> no | MinCache <> no 
	mov		ecx,0x620
	rdmsr
	and		eax,0xFFFF8080
	or		eax,ebx
	wrmsr
end if
if SystemVOffset <> no | Default = yes
	mov		ecx,0x150
	if Default = yes
		mov		eax,0x0FE00000 or Masking
	else
		mov		eax,((SystemVOffset * 33554) shl 6) and 0xFFE00000
	end if
	mov		edx,0x80000311
	wrmsr
end if
if IgnoreFIVRFaults = yes | DisableFIVREfficiency = yes
	mov		ecx,0x150
	xor     eax,eax
	mov     edx,0x80000014
	wrmsr    	
    rdmsr
	or		eax,3
	if IgnoreFIVRFaults = no & DisableFIVREfficiency = no
		xor		eax,3
	else if IgnoreFIVRFaults = no
		xor		eax,1
	else
		xor		eax,2
	end if
	mov     edx,0x80000015
	wrmsr
end if
if ChangeVCCIN <> no | LockSVID = yes | Default = yes
	mov		ecx,0x150
	xor     eax,eax
	mov     edx,0x80000012
	wrmsr
	rdmsr
	and		eax,0x7FFFF000
	if ChangeVCCIN = no | Default = yes
		or		eax,((1900 shl 10)/1000) and 0xFFF or DefMask
	else
		or		eax,((ChangeVCCIN shl 10)/1000) and 0xFFF
	end if
	if LockSVID = yes
		bts		eax,31
	end if
	mov     edx,0x80000013
	wrmsr
end if
if EditPP0_RAPL = yes | EditPKG_RAPL = yes
	mov		ecx,0x606
 	rdmsr
	and		al,0xF
	movzx	esi,al
end if
if EditPKG_RAPL = yes
	mov		ecx,0x610
 	rdmsr
	and		eax,0xFF000000
	and		edx,0xFF000000
	Picosec = PL1_Window * 1000 * 1000 * 1000 * 1000
	Exponent = 1
	lastExponent = 1
	Fraction = 0
	lastFraction = 0
	while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec 
		lastExponent = Exponent
		while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec
			lastFraction = Fraction /1000
			Fraction = Fraction + 1000
			if % = 4
				break
			end if
		end while
		if Fraction < 4000
			break
		end if
		Fraction = 0
		Exponent = Exponent + 1
	end while
	or		eax,((((lastFraction shl 5)+lastExponent)and 0x7F)shl 17) + \
	((PL1_Enabled and 1)shl 15) + ((PL1_Clamping and 1)shl 16)
	mov		ecx,esi
	mov		ebx,PL1_Power and 0xFFF
	shl		ebx,cl
	or		eax,ebx
	Picosec = PL2_Window * 1000 * 1000 * 1000
	Exponent = 1
	lastExponent = 1
	Fraction = 0
	lastFraction = 0
	while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec 
		lastExponent = Exponent
		while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec
			lastFraction = Fraction /1000
			Fraction = Fraction + 1000
			if % = 4
				break
			end if
		end while
		if Fraction < 4000
			break
		end if
		Fraction = 0
		Exponent = Exponent + 1
	end while
	or		edx,((((lastFraction shl 5)+lastExponent)and 0x7F)shl 17) + \
	((PL2_Enabled and 1)shl 15) + ((PL2_Clamping and 1) shl 16) + (1 shl 31)
	mov		ecx,esi
	mov		ebx,PL2_Power and 0xFFF
	shl		ebx,cl
	or		edx,ebx
	mov		ecx,0x610
 	wrmsr
end if
if EditPP0_RAPL = yes
	mov		ecx,0x638
 	rdmsr
	and		eax,0xFF000000
	Picosec = PP0_Window * 1000 * 1000 * 1000 * 1000
	Exponent = 1
	lastExponent = 1
	Fraction = 0
	lastFraction = 0
	while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec 
		lastExponent = Exponent
		while (1 shl Exponent)*(1000+(Fraction/4))*976562 <= Picosec
			lastFraction = Fraction /1000
			Fraction = Fraction + 1000
			if % = 4
				break
			end if
		end while
		if Fraction < 4000
			break
		end if
		Fraction = 0
		Exponent = Exponent + 1
	end while
	or		eax,((((lastFraction shl 5)+lastExponent)and 0x7F)shl 17) + \
	((PP0_Enabled and 1)shl 15) + ((PP0_Clamping and 1) shl 16) + (1 shl 31)
	mov		ecx,esi
	mov		ebx,PP0_Power and 0xFFF
	shl		ebx,cl
	or		eax,ebx
	mov		ecx,0x638
 	wrmsr
end if
if MaxCurrent <> no
	mov		ecx,0x601
	rdmsr
	if MaxCurrent > 1023
		or		eax,0x1fff + (1 shl 31)
	else
		and		eax,0xFFFFE000
		or		eax,(MaxCurrent * 8) + (1 shl 31)
	end if
	wrmsr
end if
if EnergyEfficienTurbo = no
	mov ecx,0x1fc
	rdmsr
		bts		eax,19
	wrmsr
end if
if TjmaxOffset <> no
	mov		ecx,0x1A2
	rdmsr
	and		eax,0xF0FFFFFF
	or		eax,(TjmaxOffset and 0xF)shl 24
	wrmsr
end if
If NormalRatio <> no
	mov		ecx,0x64C
 	rdmsr
	mov		al,NormalRatio and 0x7F
	or		eax,0x80000000
	wrmsr
end if
if DisableDebugFeatures = yes
	mov		ecx,0xC80
	rdmsr
	btr		eax,0
	bts		eax,30
	wrmsr
end if
if LockOC = yes
	mov		ecx,0x194
 	rdmsr
	bts		eax,20
	wrmsr
end if
if SkipBiosPM = yes
	busfinder:
		xor		ecx,ecx
	.testing:
		add		ecx,0x00010000
		mov		eax,0x800087D0
		or		eax,ecx
		mov		dx,0xCF8
		out		dx,eax
		in		eax,dx
		test	eax,0x80000000
		jz		continue
		mov		dx,0xCFC
		in		eax,dx
		cmp		eax,0xFFFFFFFF
		je		.next
		shl		eax,8
		and		eax,0x00FF0000
		cmp		eax,ecx
		je		.busOK
	.next:
		cmp		ecx,0x00FF0000
		jbe		.testing
		jmp		continue
	.busOK:
		or		eax,0x8000F194
		mov		dx,0xCF8
		out		dx,eax
		in		eax,dx
		test	eax,0x80000000
		jz		continue
		mov		dx,0xCFC
		in		eax,dx
		cmp		eax,0xFFFFFFFF
		je		continue
		bts		eax,3
		out		dx,eax
	continue:
end if
if SkipMicrocodeUpdates = yes & Default <> yes
	movd	esi,mm3
	jmp		esi
end if
endjob:	;update microcode
	db		0xE9
	dd		OriginalAddress + 0x2E2B - endjob - 5
enddriver:
	if PreviousSize > enddriver
		db PreviousSize - enddriver dup(0xFF)
	end if	
finish:
	file	INNAME:DriverAddress+finish,InjectAddress-DriverAddress-finish
	dd		0xFFFFD1D5
epilogue:
	file	INNAME:DriverAddress+epilogue