@echo off
setlocal enabledelayedexpansion
set "dv==::"
if defined !dv! goto :errorAdmin
cd /d "%~dp0"
cd Engine
fptw64.exe -D Current.bin -A 0xFF0000
if not exist Current.bin goto :errorRead
fasm Clear.asm Current.raw -d INNAME="Current.bin"
if not exist Current.raw goto :errorCompile
fptw64.exe -F Current.raw -A 0xFF0000 -REWRITE
if not %errorlevel% == 0 goto :errorFlash
:success
	cls
	echo.
	echo.
	echo.           
	echo             Patch removed ^^!
	echo.
	echo       Send PC to Sleep or Restart 
	echo		  to accept the changes
	echo.
	echo.
	goto :finish
:errorAdmin
	cls
	echo.
	echo.
	echo.           
	echo            Operation aborted ^^!
	echo.
	echo       Need Admin rights to proceed 
	echo.
	echo.
	echo.
	goto :finish
:errorRead
	cls
	echo.
	echo.
	echo.           
	echo            Operation aborted ^^!
	echo.
	echo       Cannot read current firmware
	echo.
	echo.
	echo.
	goto :finish
:errorCompile
	cls
	echo.
	echo.
	echo.           
	echo            Operation aborted ^^!
	echo.
	echo              Patch not found
	echo.
	echo.
	echo.
	echo.
	goto :finish
:errorFlash
	cls
	echo.
	echo.
	echo.           
	echo            Operation aborted ^^!
	echo.
	echo        Cannot flash the firmware
	echo.
	echo    Unlock BIOS region, restart PC, etc
	echo.
	echo.
	goto :finish
:finish
	del Current.bin > nul 2> nul
	del Current.raw > nul 2> nul
	pause
	exit